/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in 
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2007.  All Rights Reserved.
 *
 * Protege was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu.
 *
 */

package edu.stanford.smi.protegex.widget.scatterbox;

import edu.stanford.smi.protege.model.*;
import java.util.*;

/**
 *  Description of the Interface
 *
 * @author    William Grosso <grosso@smi.stanford.edu>
 */
public interface KBQueryUtils extends Constants {

    public Instance getDomainObject(Instance entry);

    // domain
    public Cls getDomainType(Cls functionCls);

    public Cls getDomainTypeFromEntryCls(Cls entryCls);

    public Collection getDomainValueSlots(Cls entryCls);

    // entry
    public Slot getEntriesSlot(Cls functionCls);

    public Cls getEntryCls(Cls functionCls);

    public Instance getOrCreateDomainObject(Instance entry);

    public Instance getOrCreateRangeObject(Instance entry);

    public Instance getRangeObject(Instance entry);

    // range
    public Cls getRangeType(Cls functionCls);

    public Cls getRangeTypeFromEntryCls(Cls entryCls);

    public Slot getRangeValueSlot(Cls entryCls);

    public Slot getRangeValueSlot(Instance entry);

    public Collection getRangeValueSlots(Cls entryCls);

    public Collection getRangeValueSlots(Instance entry);

    public void setDomainObject(Instance entry, Instance domainObject);

    public void setRangeObject(Instance entry, Instance rangeObject);
}
